#ifndef __c1_stopwatch_h__
#define __c1_stopwatch_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"
#include "rtw_capi.h"
#include "rtw_modelmap.h"

/* Type Definitions */
typedef struct {
  SimStruct *S;
  const mxArray *c1_setSimStateSideEffectsInfo;
  void *c1_testPointAddrMap[11];
  uint32_T c1_mem_minutes;
  uint32_T c1_minutes;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c1_isStable;
  uint8_T c1_doSetSimStateSideEffects;
  uint8_T c1_is_Memory;
  uint8_T c1_is_Started;
  uint8_T c1_is_Watch;
  uint8_T c1_is_active_Memory;
  uint8_T c1_is_active_Watch;
  uint8_T c1_is_active_c1_stopwatch;
  uint8_T c1_mem_seconds;
  uint8_T c1_seconds;
  uint8_T c1_tp_Count;
  uint8_T c1_tp_Disengaged;
  uint8_T c1_tp_Engaged;
  uint8_T c1_tp_Memory;
  uint8_T c1_tp_Started;
  uint8_T c1_tp_Stopped;
  uint8_T c1_tp_Watch;
  ChartInfoStruct chartInfo;
  rtwCAPI_ModelMappingInfo c1_testPointMappingInfo;
} SFc1_stopwatchInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c1_stopwatch_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c1_stopwatch_get_check_sum(mxArray *plhs[]);
extern void c1_stopwatch_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
